import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';


import * as RegistActionTypes from '../action/regist';
import RegistState, { defaultState as RegistDefaultState } from '../state/Regist';

import AuthCrawler from '../../api/model/AuthCrawler';

const reducer: ReducersMapObject = {
  [RegistActionTypes.REQUEST_SUCCESS]: (state: RegistState = RegistDefaultState,
                                        action: Action<AuthCrawler>): RegistState => {
    return {
      ...state,
      authCrawler: action.payload,
    };
  },
  [RegistActionTypes.REQUEST_FAILURE]: (state: RegistState = RegistDefaultState,
                                        action: Action<AuthCrawler>): RegistState => {
    return {
      ...state,
      error: action.error,
    };
  },
};

export default reducer;
