import * as React from 'react';
import {
  Button,
  Modal,
  Checkbox,
  Header,
  Container,
} from 'semantic-ui-react';
import { DiscoveryProbe } from './DiscoveryProbe';
import DiscoveryTableContainer from '../DiscoveryTable';
import DiscoveryTreeContainer from '../DiscoveryTree';

import Probe from '@overflow/probe/api/model/Probe';
import Host from '@overflow/discovery/api/model/Host';
import Port from '@overflow/discovery/api/model/Port';
import Service from '@overflow/discovery/api/model/Service';
import * as _ from 'lodash';

export interface StateProps {
  probeId?: Number;
  open?: boolean;
  isSuccess?: boolean;
  onClosePopup?(bool: boolean): void;
  onRefreshList?(): void;
}

export interface DispatchProps {
  onCreateTarget?(hosts: Host[], probe: Probe): void;
  onTestDiscovery?(types: string, obj: any): void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  startPopup: boolean;
  // probeTemp: any;
}


export class Discovery extends React.Component<Props, State> {

  private submitData: any;
  private discoveryHosts: Array<Host>;

  private exDisHosts: Array<Host>;

  public constructor(props: Props, context: State) {
    super(props, context);
    this.handleProbeChange.bind(this);
    this.state = {
      startPopup: false,
    };

    this.exDisHosts = hostListJson;
  }

  public componentWillMount(): void {
    // this.setState({probeTemp:probeTemp});
  }

  public componentWillReceiveProps?(nextProps: Readonly<Props>, nextContext: any): void {
    if (this.props.isSuccess === undefined || this.props.isSuccess === false) {
      if (nextProps.isSuccess === true) {
        // this.props.onClosePopup(false);
        this.props.onRefreshList();
      }
    }

  }

  public handleProbeChange(obj: Object): void {
    console.log(obj);
    this.setState({ startPopup: true });
    // this.submitData = obj;
  }

  public handleSubmit(): void {
    // console.log(this.discoveryHosts);
    this.setState({ startPopup: false });
    this.props.onCreateTarget(this.discoveryHosts, { id: Number(this.props.probeId) });
  }

  public onSetTargetList = (discoveryHosts: Array<Host>) => {
    this.discoveryHosts = discoveryHosts;
  }

  public handleCancel = () => this.setState({ startPopup: false });

  public handleTest = () => {

    let min: number = 1;
    let max: number = 2;

    let idx: number = Math.floor(Math.random() * (max - min + 1) + min);

    idx = 2;

    switch(idx) {
      case 1:
      this.testHost();
      break;
      case 2:
      this.testPort();
      break;
      case 3:
      this.testService();
      break;
      default:
      break;
    }
  }
  public testHost(): void {
    let min: number = 0;
    let max: number = this.exDisHosts.length - 1;

    let idx: number = Math.floor(Math.random() * (max - min + 1) + min);

    console.log('idx ----' + idx);
    let host: Host = this.exDisHosts[idx];
    console.log(host);
    let chkObj: Object = host;
    if(chkObj.hasOwnProperty('ports')) {
      host.ports = null;
    }

    this.props.onTestDiscovery('1', host);
  }
  public testPort(): void {
    let min: number = 0;
    let max: number = this.exDisHosts.length - 1;

    let idx: number = Math.floor(Math.random() * (max - min + 1) + min);

    console.log('host index - ' + idx);
    let host: Host = this.exDisHosts[idx];

    let checkObj: object = host;
    if(checkObj.hasOwnProperty('ports') === false) {
      return;
    }
    if(host.ports === null) {
      return;
    }
    // if(host.ports === undefined || host.ports === null) {
    //   return;
    // }

    let portmin: number = 0;
    let portmax: number = host.ports.length - 1;

    let portIdx: number = Math.floor(Math.random() * (portmax - portmin + 1) + portmin);

    let port: Port = host.ports[portIdx];

    let cHost: Host = _.clone(host);

    let chkObj: Object = cHost;
    if(chkObj.hasOwnProperty('ports')) {
      cHost.ports = null;
    }

    port.host = cHost;

    this.props.onTestDiscovery('2', port);
  }
  public testService(): void {
    let min: number = 0;
    let max: number = this.exDisHosts.length - 1;

    let idx: number = Math.floor(Math.random() * (max - min + 1) + min);

    console.log('idx ----' + idx);
    let host: Host = this.exDisHosts[idx];
    console.log(host);
    this.props.onTestDiscovery('1', this.exDisHosts[idx]);
  }

  public handlePopupClose = () => this.setState({ startPopup: false });

  public render(): JSX.Element {
    return (
      <Modal
        open={this.props.open}
      >
        <Modal.Content>
          <Container fluid>
            <Header as='h3' dividing> Discovery Details</Header>
            <br />
            <DiscoveryTableContainer onProbeChange={this.handleProbeChange.bind(this)} />

            <Modal size='small' open={this.state.startPopup} onClose={this.handlePopupClose}>
              <Modal.Header>Discovery</Modal.Header>
              <Modal.Content >
                <DiscoveryTreeContainer probeId={this.props.probeId} onSetTargetList={this.onSetTargetList.bind(this)} />
              </Modal.Content>
              <Modal.Actions>
                <Button onClick={this.handleCancel}>              Cancel      </Button>
                <Button onClick={this.handleTest}>              Test      </Button>
                <Button onClick={this.handleSubmit.bind(this)} primary>              Submit      </Button>
              </Modal.Actions>
            </Modal>

          </Container>
        </Modal.Content>
        <Modal.Actions>
          <Button onClick={() => this.props.onClosePopup(false)}>Cancel</Button>
          {/* <Button primary >Done</Button> */}
        </Modal.Actions>
      </Modal>


    );
  }
}



const hostListJson: any = [
  {
    'firstScanRange': 1,
    'lastScanRange': 10000,
    'name': '',
    'ip': 3232235818,
    'mac': 91754662925,
    'os': 'Windows',
    'ports': [{
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'SSH',
        'target': true,
      }],
      'portType': 'TCP',
      'portNumber': 22,
    },
    {
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'HTTP',
      }],
      'portType': 'TCP',
      'portNumber': 443,
    },
    {
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'HTTP',
      }],
      'portType': 'TCP',
      'portNumber': 80,
    }],
    'createDate': 1498470178000,
    'updateDate': 1498470178000,
  },
  {
    'firstScanRange': 1,
    'lastScanRange': 10000,
    'name': '',
    'ip': 3232235781,
    'mac': 91754660625,
    'os': 'Windows',
    'ports': [{
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'SSH',
      }],
      'portType': 'TCP',
      'portNumber': 22,
    },
    {
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'HTTP',
      }],
      'portType': 'TCP',
      'portNumber': 80,
    },
    {
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'HTTP',
      }],
      'portType': 'TCP',
      'portNumber': 1936,
    },
    {
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': null,
      'portType': 'TCP',
      'portNumber': 443,
    }],
    'createDate': 1498470178000,
    'updateDate': 1498470178000,
  },
  {
    'firstScanRange': 1,
    'lastScanRange': 10000,
    'name': '',
    'ip': 3232235797,
    'mac': 91754662913,
    'os': 'Windows',
    'target': true,
    'ports': [{
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'HTTP',
      }],
      'portType': 'TCP',
      'portNumber': 80,
    },
    {
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'SSH',
      }],
      'portType': 'TCP',
      'portNumber': 22,
    },
    {
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'HTTP',
      }],
      'portType': 'TCP',
      'portNumber': 3343,
    },
    {
      'createDate': -62135596800000,
      'updateDate': -62135596800000,
      'services': [{
        'createDate': -62135596800000,
        'updateDate': -62135596800000,
        'portType': 'TCP',
        'serviceName': 'HTTP',
      }],
      'portType': 'TCP',
      'portNumber': 443,
    }],
    'createDate': 1498470178000,
    'updateDate': 1498470178000,
  },
  {
    'firstScanRange': 1,
    'lastScanRange': 10000,
    'name': '',
    'ip': 3232235877,
    'mac': 75361038758387,
    'os': 'Windows',
    'ports': null,
    'createDate': 1498470179000,
    'updateDate': 1498470179000,
  },


];
