import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import * as _ from 'lodash';

import Host from '../../api/model/Host';
import Port from '../../api/model/Port';
import Service from '../../api/model/Service';

import * as IngActionTypes from '../action/ing';
import {
  HostState, hostDefaultState,
  PortState, portDefaultState,
  ServiceState, serviceDefaultState,
  DiscoveryIngState, DiscoveryIngDefaultState,
} from '../state/Ing';

const reducer: ReducersMapObject = {
  [IngActionTypes.RECEIVE_HOST]: (state: DiscoveryIngState = DiscoveryIngDefaultState,
                                  action: Action<Host>): DiscoveryIngState => {

    let obj: any = action.payload;
    let hostList: Host[] = null;
    if(state.hostList === null || state.hostList === undefined) {
      hostList = new Array();
      hostList.push(JSON.parse(obj));
    } else {
      hostList = _.clone(state.hostList);
      hostList.push(JSON.parse(obj));
    }

    return {
      ...state,
      hostList: hostList,
    };
  },
  [IngActionTypes.RECEIVE_PORT]: (state: DiscoveryIngState = DiscoveryIngDefaultState,
                                  action: Action<Port>): DiscoveryIngState => {

    let hostList: Host[] = null;
    let obj: any = action.payload;
    if(state.hostList === null || state.hostList === undefined) {
      hostList = new Array();
      let port: Port = JSON.parse(obj);
      let host: Host = _.clone(port.host);
      host.ports = new Array();
      port.host = host;
      host.ports.push(port);
      hostList.push(port.host);

    } else {
      hostList = _.clone(state.hostList);
      let port: Port = JSON.parse(obj);
      // let host: Host = _.clone(port.host);

      let tHost: Host = null;
      for(let h of hostList) {
        if(h.ip === port.host.ip) {
          tHost = h;
          port.host = h;
          if(h.ports === null || h.ports === undefined) {
            h.ports = new Array();
          }
          h.ports.push(port);
          break;
        }
      }
      let dIdx: number = hostList.indexOf(tHost, 0);
      if(dIdx > -1) {
        hostList.slice(dIdx, 1);
        hostList.push(tHost);
      } else {
        let host: Host = _.clone(port.host);
        host.ports = new Array();
        port.host = host;
        host.ports.push(port);
        hostList.push(host);
      }


    }

    return {
      ...state,
      hostList: hostList,
    };
  },
  [IngActionTypes.RECEIVE_SERVICE]: (state: DiscoveryIngState = DiscoveryIngDefaultState,
                                     action: Action<Service>): DiscoveryIngState => {



    return {
      ...state,
      // service: action.payload,
    };
  },
};

export default reducer;
