import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';


import * as InfraTargetRegistAllActionTypes from '../action/start';
import StartState, { defaultState as startDefaultState } from '../state/Start';

const reducer: ReducersMapObject = {
  [InfraTargetRegistAllActionTypes.REQUEST_SUCCESS]: (state: StartState = startDefaultState,
                                                      action: Action<boolean>): StartState => {
    return {
      ...state,
      isStartDiscoverySuccess: action.payload,
    };
  },
  [InfraTargetRegistAllActionTypes.REQUEST_FAILURE]: (state: StartState = startDefaultState,
                                                      action: Action<Error>): StartState => {
    return {
      ...state,
      error: action.error,
    };
  },
};

export default reducer;
