import { connect, Dispatch } from 'react-redux';
import Member from '../api/model/Member';

import {
  SignUp,
  StateProps as SignUpStateProps,
  DispatchProps as SignUpDispatchProps,
} from './components/SignUp';

import { push as routerPush } from 'react-router-redux';
import * as signupActions from '../redux/action/signUp';
import * as asyncRestRequestAction from '@overflow/commons/redux/action/asyncRestRequest';

export function mapStateToProps(state: any): SignUpStateProps {
  return {
    member: state.member,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): SignUpDispatchProps {
  return {
    onSignUp: (member: Member) => {
      // dispatch(asyncRequestActions.request('MemberService', 'signup', signupActions.REQUEST, JSON.stringify(member), member.pw));
      // dispatch(signupActions.request(member));
      dispatch(asyncRestRequestAction.request('/account/signup', 'POST', signupActions.REQUEST, {member:member}));

    },
    onRedirectHome: () => {
      dispatch(routerPush('/'));
    },
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(SignUp);
