import *as React from 'react';
import {
  Input,
  InputOnChangeData,
  Select,
  Button,
  Modal,
  Form,
  ButtonProps,
  Grid,
  Header,
} from 'semantic-ui-react';

import 'whatwg-fetch';

const options = [
  { key: 'southkorea', value: '82', text: 'South Korea(82)' },
  { key: 'unitedstates', value: '1', text: 'United States(1)' },
];
export interface StateProps {
  isAuthenticated?:boolean;
  error?:Error;
}

export interface DispatchProps {
  onSignIn?(signinId: string, signinPw: string ): void;
  onForgotPassword?(email:string): void;
  onSignUp?(): void;
  onResetPassword?():void;
  onRedirectHome():void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  forgotPopup: boolean;
  sendComPopup: boolean;
  email: string;
  pass: string;
}

export class SignIn extends React.Component<Props, State> {
  get sendComOpen(): () => any {
    return this._sendComOpen;
  }

  set sendComOpen(value: () => any) {
    this._sendComOpen = value;
  }
  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {
      forgotPopup: false,
      sendComPopup: false,
      email: 'overflow@loafle.com',
      pass: '!@#$qwer1234',
    };
  }

  public render(): JSX.Element {
    let signinElement = <Form>
      <Form.Input fluid placeholder='Email' defaultValue={this.state.email} onChange={
        (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
          this.setState({ email: data.value });
        }} />
      <Form.Input fluid placeholder='Password' defaultValue={this.state.pass} type='password' onChange={
        (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
          this.setState({ pass: data.value });
        }} />
      <div style={{textAlign:'right'}}>
        <Button size='tiny' style={{background:'#fff'}} onClick={this.forgotPopupOpen}>Forgot Password?</Button>
      </div>
      <Form.Group>
        <Button fluid primary style={{margin:'7'}} onClick={ this.signInClick.bind(this) }>    Sign In  </Button>
        <Button fluid style={{margin:'7'}} href='/#/test2'>    Sign Up  </Button>
      </Form.Group>

      <Modal size='small' open={this.state.forgotPopup} onClose={this.PopupClose}>
        <Modal.Header>Change your password</Modal.Header>
        <Modal.Content >
          Enter email address
          <Grid centered>
            <Grid.Column mobile={14} tablet={10} computer={10}>
              <Input fluid placeholder='Email' onChange={
                (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                  this.setState({ email: data.value });
                }} />
            </Grid.Column>
          </Grid>
        </Modal.Content>
        <Modal.Actions>
          <Button primary onClick={this._sendComOpen}>              Submit      </Button>
          <Button onClick={this.PopupClose}>              Cancel      </Button>
        </Modal.Actions>
      </Modal>

      <Modal size='small' open={this.state.sendComPopup} onClose={this.PopupClose}>
        <Modal.Header>Send Complete</Modal.Header>
        <Modal.Content>
          <Modal.Description>
            <Header>비밀번호 변경이 신청 되었습니다.</Header>
            <p>수신하신 메일의 주소에서 비밀번호 변경을 완료 하시기 바랍니다.</p>
          </Modal.Description>
        </Modal.Content>
        <Modal.Actions>
          <Button primary onClick={this.PopupClose}>              Ok      </Button>
        </Modal.Actions>
      </Modal>
    </Form>;

    if( this.props.isAuthenticated ) {
      this.props.onRedirectHome();
      return null;
    } else {
      return signinElement;
    }
  }

  private forgotPopupOpen = () => this.setState({ forgotPopup: true });
  private PopupClose = () => this.setState({ forgotPopup: false, sendComPopup: false });
  private _sendComOpen = () => {
    this.setState({
      forgotPopup: false,
      sendComPopup: true,
    });

    this.props.onForgotPassword(this.state.email);
    // Todo Ajax
    // this.testhttp();
  }

  // private async testhttp() {
  //   // let httpc: httpm.HttpClient = new httpm.HttpClient('vsts-node-api');
  //   // let res:httpm.HttpClientResponse = await httpc.get('http://192.168.1.103:19080/forgot_password?');
  //   // let body: string = await res.readBody();
  //   // console.log(body, res.message);
  //
  //   let d: any = await fetch('http://192.168.1.103:19080/account/forgot_password', {
  //     method: 'POST',
  //     headers: {
  //       // 'Content-Type': 'text/plain; charset=utf-8',
  //       'Accept': 'application/json',
  //       'Content-Type': 'application/json',
  //     },
  //     body: JSON.stringify({
  //       signinId: 'geek@loafle.com',
  //     }),
  //
  //   }).then((respnse:any) => {
  //     console.log(respnse);
  //     return respnse.json();
  //   }).then((resData:any) => {
  //     console.log('resdata' + resData);
  //     return resData;
  //   }).catch(err => {
  //     console.log('eee' + err);
  //   });
  //   // let re: any = await d.json();
  //
  //   // console.log(d);
  // }

  private signInClick(event: React.SyntheticEvent<HTMLButtonElement>, data: ButtonProps):void {
    this.props.onSignIn(this.state.email, this.state.pass);
  }
}
